<?php

if(!defined('DOKU_INC')) die();

class action_plugin_authuffd extends DokuWiki_Action_Plugin
{
	function register(Doku_Event_Handler $controller)
	{
		global $conf;
		if($conf['authtype'] != 'authuffd')
			return;
		$conf['profileconfirm'] = false; /* password confirmation doesn't work with SSO users */
		$controller->register_hook('FORM_LOGIN_OUTPUT', 'BEFORE', $this, 'handle_loginform');
		$controller->register_hook('HTML_LOGINFORM_OUTPUT', 'BEFORE', $this, 'handle_loginform_old');
	}

	function handle_loginform(Doku_Event &$event)
	{
		$form = $event->data;
		do {
			$form->removeElement(0);
		} while ($form->elementCount() > 0);
		$form->addFieldsetOpen('Login with:');
		$form->setHiddenField('oauth2_login', '1');
		$form->addButton('', $this->getConf('name'))->attr('type', 'submit');
		$form->addFieldsetClose();
	}

	function handle_loginform_old(Doku_Event &$event, $param)
	{
		$event->data->_content = array(
			form_openfieldset(array('_legend' => 'Login with:', 'class' => 'plugin_authuffd')),
			form_hidden(array('name' => 'oauth2_login', 'value' => '1')),
			form_button(array('type' => 'submit', 'value' => htmlspecialchars($this->getConf('name')))),
			form_closefieldset()
		);
	}
}
